// StartCtl.cpp : Implementation of the CStartCtrl ActiveX Control class.

#include "stdafx.h"
#include "Start.h"
#include "StartCtl.h"
#include "StartPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CStartCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CStartCtrl, COleControl)
	//{{AFX_MSG_MAP(CStartCtrl)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CStartCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CStartCtrl)
	DISP_PROPERTY_NOTIFY(CStartCtrl, "MyName", m_strMyName, OnMyNameChanged, VT_BSTR)
	DISP_FUNCTION(CStartCtrl, "CallMeIn10Seconds", CallMeIn10Seconds, VT_EMPTY, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CStartCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CStartCtrl, COleControl)
	//{{AFX_EVENT_MAP(CStartCtrl)
	EVENT_CUSTOM("DidYouCallMe", FireDidYouCallMe, VTS_NONE)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CStartCtrl, 1)
	PROPPAGEID(CStartPropPage::guid)
END_PROPPAGEIDS(CStartCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CStartCtrl, "START.StartCtrl.1",
	0x63c4e7c7, 0x5286, 0x40d3, 0x95, 0xcf, 0xcb, 0x29, 0xde, 0x1, 0x73, 0xd3)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CStartCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DStart =
		{ 0x83267ac4, 0x1aa, 0x4bc7, { 0x91, 0xde, 0xda, 0x8e, 0xc6, 0xff, 0xae, 0x91 } };
const IID BASED_CODE IID_DStartEvents =
		{ 0x313d6d48, 0x7c73, 0x4d52, { 0x88, 0xca, 0xa7, 0xcc, 0x86, 0x35, 0x1c, 0xb5 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwStartOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CStartCtrl, IDS_START, _dwStartOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::CStartCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CStartCtrl

BOOL CStartCtrl::CStartCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister)
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_START,
			IDB_START,
			afxRegApartmentThreading,
			_dwStartOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::CStartCtrl - Constructor

CStartCtrl::CStartCtrl()
{
	InitializeIIDs(&IID_DStart, &IID_DStartEvents);

	// TODO: Initialize your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::~CStartCtrl - Destructor

CStartCtrl::~CStartCtrl()
{
	// TODO: Cleanup your control's instance data here.
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::OnDraw - Drawing function

void CStartCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	// TODO: Replace the following code with your own drawing code.
	pdc->FillRect(rcBounds, CBrush::FromHandle((HBRUSH)GetStockObject(WHITE_BRUSH)));
	pdc->Rectangle(rcBounds);
	pdc->TextOut(10,10,"Ϸ ƮԴϴ.");
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::DoPropExchange - Persistence support

void CStartCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.
	PX_String(pPX , _T("MyName") , m_strMyName, "unknown");
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::OnResetState - Reset control to default state

void CStartCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl::AboutBox - Display an "About" box to the user

void CStartCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_START);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CStartCtrl message handlers

void CStartCtrl::OnMyNameChanged() 
{
	// TODO: Add notification handler code

	SetModifiedFlag();
}

void CStartCtrl::CallMeIn10Seconds() 
{
	// TODO: Add your dispatch handler code here
	SetTimer(0,10000,NULL);	//10ʵڿ ð ߻
}

void CStartCtrl::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	KillTimer(0);
	FireDidYouCallMe();
	COleControl::OnTimer(nIDEvent);
}

